#define _XOPEN_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#define KEY 175

int main() {
	struct sembuf pbuf[3] = {
		{0, -1, 0},
		{1, -1, 0},
		{2, -1, 0}};
	struct sembuf vbuf[3] = {
		{0, 1, 0},
		{1, 1, 0},
		{2, 1, 0}};

	srand48(getpid());
	int ident_sem = semget(KEY, 3, 0777);

	//  sem 0 - buffer not empty
	//	sem 1 - buffer not full
	//	sem 2 - lock for buffer operations

	semop(ident_sem, pbuf+1, 1);
	semop(ident_sem, pbuf+2, 1);
	printf("Producer %d start\n", getpid());
	sleep(lrand48() % 4 + 1);
	printf("Producer %d end\n", getpid());
	semop(ident_sem, vbuf+2, 1);
	semop(ident_sem, vbuf, 1);
	return 0;
}

